import React, { useCallback, useEffect, useMemo, useRef, useState } from 'react'
import styles from './index.module.scss'
import { useParams } from 'react-router-dom'
import { Button, Cascader, Checkbox, Input } from 'antd'
import ZRichTexts from '@/components/ZRichTexts'
import MyPopconfirm from '@/components/MyPopconfirm'
import history, {
  btnFlagFu2,
  cascaderObjFu,
  infoPageBackFu,
  openGoodsInfoFu
} from '@/utils/history'
import { MessageFu } from '@/utils/message'
import MyTable from '@/components/MyTable'
import classNames from 'classnames'
import { D4goodsTableC, statusObj } from '@/utils/tableData'
import ZGaddNow from '@/components/ZGaddNow'
import X3auditInfo from '@/pages/X_stock/X3auditInfo'
import ZflowTable from '@/components/ZflowTable'
import { C1GoodType } from '@/pages/A3_ledger/C1ledger/type'
import { EXbtnFu } from '@/utils/EXBtn'
import {
  C21_APIcreate,
  C21_APIdel,
  C21_APIDownloadBatchZip,
  C21_APIgetInfo,
  C21_APIsaveApply,
  C21_APIsaveAudit,
  C21_APIsaveCreate,
  C21_APIsaveDraft
} from '@/store/action/C21wealth'
import { MEDIA_TYPES } from '../constants'
import { IC21Detail } from '../types'
import { EXPORT_WORD_ENUM } from '@/utils/exportTemplates'

export const pageTitTxtObj = {
  1: '新增',
  2: '编辑',
  3: '审批',
  4: '查看'
}

function C21edit() {
  const { key, id } = useParams<any>()
  // key:1 新增 2编辑 3审批 4查看

  // 滚到顶部
  const sollrDom = useRef<HTMLDivElement>(null)

  // 顶部数据
  const [topInfo, setTopInfo] = useState({
    sonTypeName: '',
    effect: ''
  } as IC21Detail)

  // 藏品清单快照数据
  const [snaps, setSnaps] = useState<C1GoodType[]>([])
  const delSnapIdsRef = useRef<number[]>([])

  const snapsID2ref = useRef<{ goodsId: number; id: number }[]>([])

  // 创建订单
  const creatFu = useCallback(async () => {
    const res = await C21_APIcreate()
    if (res.code === 0) {
      setTopInfo({ ...res.data, sonTypeName: MEDIA_TYPES.map(i => i.value).join(',') })
    }
  }, [])

  // 获取详情
  const getInfoFu = useCallback(
    async (id2?: number) => {
      const res = await C21_APIgetInfo(id2 || id)
      if (res.code === 0) {
        setTopInfo(res.data)

        // 设置富文本
        ZRichTextRef.current?.ritxtShowFu(JSON.parse(res.data.rtf || '{}'))

        // 藏品清单快照信息id对比
        const arrTemp: any = []
        const snapsTemp = res.data.snaps || []

        snapsTemp.forEach((v: any) => {
          snapsID2ref.current.push({ goodsId: v.goodsId, id: v.id })

          const obj = JSON.parse(v.snap || '{}')
          if (obj.id) obj.id2 = v.id

          arrTemp.push(obj)
        })
        setSnaps(arrTemp)
      }
    },
    [id]
  )

  useEffect(() => {
    if (key === '1') creatFu()
    else getInfoFu()

    if (sollrDom.current) sollrDom.current.scrollTop = 0
  }, [creatFu, getInfoFu, key])

  // 富文本的ref
  const ZRichTextRef = useRef<any>(null)

  // 审批意见的ref
  const ZAuditRef = useRef<any>(null)

  const pageTitTxt = useMemo(() => {
    return Reflect.get(pageTitTxtObj, key)
  }, [key])

  const checkDataFu = useCallback(() => {
    if (!topInfo.effect) {
      MessageFu.warning('请选择使用途径')
      return true
    }
    if (!topInfo.sonTypeName) {
      MessageFu.warning('请选择资源类型')
      return true
    }

    return false
  }, [topInfo])

  // 审批的sta
  const [auditSta, setAuDitSta] = useState('')

  // 新增的底部按钮点击
  const btnClickFu = useCallback(
    async (val: '草稿' | '创建' | '保存' | '审批') => {
      if (checkDataFu()) return

      if (val !== '草稿') {
        if (snaps.length === 0) return MessageFu.warning('请添加藏品')
      }

      if (val === '审批') {
        // console.log('审批信息富文本', rtf2)
        if (!auditSta) {
          if (sollrDom.current) sollrDom.current.scrollTop = 0
          return MessageFu.warning('请选择审批结果')
        }
        const rtf2 = ZAuditRef.current?.resData()

        const res = await C21_APIsaveAudit({
          orderId: topInfo.id,
          rtfOpinion: rtf2,
          status: auditSta === '同意' ? 1 : 2
        })

        if (res.code === 0) {
          MessageFu.success('审批成功')
          // 跳详情页
          history.push(`/wealth_edit/4/${topInfo.id}`)
        }
      } else {
        const rtf1 = ZRichTextRef.current?.fatherBtnOkFu() || { flag: true }
        // console.log('申请信息富文本', JSON.stringify(rtf1.val || ''))

        const obj = {
          ...topInfo,
          rtf: JSON.stringify(rtf1.val || ''),
          goodsIds: snaps.map(v => v.id).join(','),
          delSnapIds: delSnapIdsRef.current.length ? delSnapIdsRef.current : '',
          snaps: snaps.map(v => ({
            goodsId: v.id,
            id: v.id2 ? v.id2 : null,
            orderId: topInfo.id,
            snap: JSON.stringify(v)
          }))
        }
        // console.log(123, obj)

        // if (1 + 1 === 2) return

        if (val === '草稿') {
          // 存草稿 当前页保存 不跳转
          const res = await C21_APIsaveDraft(obj)
          if (res.code === 0) {
            MessageFu.success('草稿保存成功')
            getInfoFu(topInfo.id)
          }
        } else {
          const res = val === '创建' ? await C21_APIsaveCreate(obj) : await C21_APIsaveApply(obj)
          if (res.code === 0) {
            MessageFu.success(`${val}成功`)
            // 跳到详情页
            history.push(`/wealth_edit/4/${topInfo.id}`)
          }
        }
      }
    },
    [checkDataFu, snaps, auditSta, topInfo, getInfoFu]
  )

  // 打开侧边栏
  const [cathet, setCathet] = useState(0)

  const downloadBatchZip = async (ids: (string | number)[]) => {
    const { data } = await C21_APIDownloadBatchZip(ids)
    const a = document.createElement('a')
    const arr = data.split('/')
    a.href = baseUrlTempOne + data
    a.download = arr[arr.length - 1]
    a.click()
  }

  const startBtn = useMemo(() => {
    return [
      {
        title: '藏品编号',
        render: (item: C1GoodType) => {
          return (
            <span
              onClick={() => setCathet(item.id)}
              className={classNames('D1GtNum', item.id === cathet ? 'D1GtNumAc' : '')}
            >
              {item.num}
            </span>
          )
        }
      }
    ]
  }, [cathet])

  const tableLastBtn = useMemo(() => {
    return [
      {
        title: '操作',
        render: (item: C1GoodType) => {
          return (
            <>
              <Button size='small' type='text' onClick={() => openGoodsInfoFu(item.id, 20)}>
                查看
              </Button>
              <Button size='small' type='text' onClick={() => downloadBatchZip([item.id])}>
                下载资源
              </Button>
              {['3', '4'].includes(key) ? null : (
                <MyPopconfirm
                  txtK='删除'
                  onConfirm={() => setSnaps(snaps.filter(v => v.id !== item.id))}
                />
              )}
            </>
          )
        }
      }
    ]
  }, [key, snaps])

  // 点击新增
  const [nowSta, setNowSta] = useState({ key: '', id: '' })

  // 查看的按钮创建-提交-撤回
  const lookBtnFu = useCallback(
    async (val: '创建' | '提交') => {
      const rtf1 = ZRichTextRef.current?.fatherBtnOkFu() || { flag: true }
      // console.log('申请信息富文本', JSON.stringify(rtf1.val || ''))

      const obj = {
        ...topInfo,
        rtf: JSON.stringify(rtf1.val || ''),
        goodsIds: snaps.map(v => v.id).join(','),
        delSnapIds: delSnapIdsRef.current.length ? delSnapIdsRef.current : '',
        snaps: snaps.map(v => ({
          goodsId: v.id,
          id: v.id2 ? v.id2 : null,
          orderId: topInfo.id,
          snap: JSON.stringify(v)
        }))
      }

      const res = val === '创建' ? await C21_APIsaveCreate(obj) : await C21_APIsaveApply(obj)

      if (res.code === 0) {
        if (sollrDom.current) sollrDom.current.scrollTop = 0
        MessageFu.success(val + '成功')
        getInfoFu()
      }
    },
    [getInfoFu, topInfo, snaps]
  )

  // 查看模式点击删除
  const delFu = useCallback(async () => {
    const res = await C21_APIdel(id)
    if (res.code === 0) {
      MessageFu.success('删除成功')
      history.push('/wealth')
    }
  }, [id])

  // 查看模式点击审批 编辑
  const lookJumpFu = useCallback(
    (val: '审批' | '编辑') => {
      history.push(`/wealth_edit/${val === '审批' ? 3 : 2}/${id}`)
      MessageFu.success(`已跳转至${val}页面`)
    },
    [id]
  )

  // 查看模式下的按钮
  const lookBtn = useMemo(() => {
    return (
      <>
        {btnFlagFu2(topInfo)['创建'] ? (
          <Button type='primary' onClick={() => lookBtnFu('创建')}>
            创建
          </Button>
        ) : null}
        {btnFlagFu2(topInfo)['提交'] ? (
          <Button type='primary' onClick={() => lookBtnFu('提交')}>
            提交
          </Button>
        ) : null}

        {btnFlagFu2(topInfo)['审批'] ? (
          <Button type='primary' onClick={() => lookJumpFu('审批')}>
            审批
          </Button>
        ) : null}
        {btnFlagFu2(topInfo)['编辑'] ? (
          <Button type='primary' onClick={() => lookJumpFu('编辑')}>
            编辑
          </Button>
        ) : null}

        {btnFlagFu2(topInfo)['重新提交'] ? (
          <Button type='primary' onClick={() => lookBtnFu('提交')}>
            重新提交
          </Button>
        ) : null}

        {EXbtnFu(topInfo, [EXPORT_WORD_ENUM.FORM_FOR_DIGITAL])}

        {btnFlagFu2(topInfo)['删除'] ? (
          <MyPopconfirm
            txtK='删除'
            onConfirm={() => delFu()}
            Dom={
              <Button type='primary' danger>
                删除
              </Button>
            }
          />
        ) : null}

        <Button onClick={() => infoPageBackFu('/wealth')}>返回</Button>
      </>
    )
  }, [delFu, lookBtnFu, lookJumpFu, topInfo])

  // 申请记录
  const [auditsShow, setAuditsShow] = useState(false)

  return (
    <div className={styles.C21edit}>
      <div className='pageTitle'>资源使用-{pageTitTxt}</div>

      <div className='D4main' ref={sollrDom}>
        {['3'].includes(key) ? (
          <X3auditInfo
            dirCode='D4wealth'
            myUrl='cms/orderIn/upload'
            auditSta={auditSta}
            auditStaFu={val => setAuDitSta(val)}
            ref={ZAuditRef}
          />
        ) : null}

        {/* 表单字段、附件等 */}
        <div className='D4Tit'>
          申请信息
          {key === '1' ? null : (
            <Button type='dashed'>{Reflect.get(statusObj, topInfo.status)}</Button>
          )}
        </div>
        <div className='D4rowAll'>
          <div className='D4row'>
            <div className='D4rowll'>业务单号：</div>
            <div className='D4rowrr'>{topInfo.num}</div>
          </div>

          <div className='D4row'>
            <div className='D4rowll'>业务名称：</div>
            <div className='D4rowrr'>{topInfo.name}</div>
          </div>

          <div className='D4row'>
            <div className='D4rowll'>发起人：</div>
            <div className='D4rowrr'>
              {topInfo.creatorName || ''} - {topInfo.createTime || ''}
            </div>
          </div>

          <div className='D4row'>
            <div className='D4rowll'>发起部门：</div>
            <div className='D4rowrr'>{topInfo.deptName}</div>
          </div>

          <div className='D4row'>
            <div className='D4rowll'>
              <span> * </span>使用途径：
            </div>
            <div className='D4rowrr'>
              {topInfo.num && (
                <Cascader
                  defaultValue={topInfo.effect ? topInfo.effect.split(',') : undefined}
                  disabled={['3', '4'].includes(key)}
                  options={cascaderObjFu()['附件用途']}
                  onChange={e => setTopInfo({ ...topInfo, effect: e ? e.join(',') : '' })}
                  placeholder='请选择'
                  fieldNames={{ label: 'name', value: 'id', children: 'children' }}
                />
              )}
            </div>
          </div>

          <div className='D4row'>
            <div className='D4rowll'>原因事由：</div>
            <div className='D4rowrr'>
              <Input
                value={topInfo.reason}
                onChange={e => setTopInfo({ ...topInfo, reason: e.target.value })}
                readOnly={['3', '4'].includes(key)}
                placeholder='请输入内容'
                maxLength={30}
                showCount
              />
            </div>
          </div>

          <div className='D4row D4rowFull' style={{ margin: '0 0 20px' }}>
            <div className='D4rowll'>
              <span> * </span>资源类型：
            </div>
            <div className='D4rowrr'>
              {topInfo.num && (
                <Checkbox.Group
                  defaultValue={topInfo.sonTypeName.split(',')}
                  disabled={['3', '4'].includes(key)}
                  options={MEDIA_TYPES}
                  onChange={e => setTopInfo({ ...topInfo, sonTypeName: e.join(',') })}
                />
              )}
            </div>
          </div>

          <div className='D4row D4rowFull' style={{ margin: 0 }}>
            <div className='D4rowll'>备注：</div>
            <div className='D4rowrr'>
              <ZRichTexts
                check={false}
                params={{
                  moduleId: topInfo.id
                }}
                dirCode='wealth'
                myUrl='cms/orderIn/upload'
                isLook={['3', '4'].includes(key)}
                ref={ZRichTextRef}
                isOne={true}
                upAudioBtnNone={true}
              />
            </div>
          </div>
        </div>

        {/* 藏品清单 */}
        <div className='D4googsBox'>
          <div className='D4Tit2'>
            <div className='D4Tit2ll'>藏品清单</div>
            <div className='D4Tit2rr'>
              <Button
                disabled={!snaps.length}
                type='primary'
                onClick={() => downloadBatchZip(snaps.map(i => i.id))}
              >
                下载所有资源
              </Button>
              {['3', '4'].includes(key) ? null : (
                <>
                  <Button
                    type='primary'
                    onClick={() => {
                      setNowSta({ key: '5', id: 'cms/orderZy/goods/getList' })
                    }}
                  >
                    新增
                  </Button>
                </>
              )}
            </div>
          </div>

          {/* 表格 */}
          <MyTable
            list={snaps}
            columnsTemp={D4goodsTableC}
            startBtn={startBtn}
            lastBtn={tableLastBtn}
            pagingInfo={false}
          />
        </div>

        {/* 申请流程 */}
        {auditsShow ? (
          <ZflowTable tableArr={topInfo.audits || []} closeFu={() => setAuditsShow(false)} />
        ) : null}
      </div>

      {/* 底部按钮 */}
      <div className='D4btn'>
        {['3', '4'].includes(key) &&
        topInfo.audits &&
        topInfo.audits.length &&
        [2, 3, 4].includes(topInfo.status) ? (
          <Button type='primary' onClick={() => setAuditsShow(true)}>
            申请记录
          </Button>
        ) : null}

        {key === '4' ? (
          lookBtn
        ) : (
          <>
            {key === '3' ? (
              <Button type='primary' onClick={() => btnClickFu('审批')}>
                审批
              </Button>
            ) : (
              <Button type='primary' onClick={() => btnClickFu(key === '1' ? '创建' : '保存')}>
                {key === '1' ? '创建' : '保存'}
              </Button>
            )}

            {key === '1' ? (
              <Button type='primary' onClick={() => btnClickFu('草稿')}>
                存草稿
              </Button>
            ) : null}

            <MyPopconfirm txtK='取消' onConfirm={() => history.push('/wealth')} />
          </>
        )}
      </div>

      {/* 新增弹窗 */}
      {nowSta.id ? (
        <ZGaddNow
          menuId={20}
          orderId={topInfo.id}
          nowSta={nowSta}
          closeFu={() => setNowSta({ key: '', id: '' })}
          dataResFu={data => {
            const dataTemp = [...data]
            dataTemp.forEach(v => {
              // id2表示的是自己这条数据的id id才是goodsId
              const obj = snapsID2ref.current.find(c => c.goodsId === v.id)

              if (obj) v.id2 = obj.id
            })
            setSnaps(dataTemp)
          }}
          oldCheckArr={snaps}
        />
      ) : null}
    </div>
  )
}

const MemoC21edit = React.memo(C21edit)

export default MemoC21edit
